import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JLabel;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JOptionPane;


public class FinestraInput extends JFrame implements ActionListener
{
    
    Sequenza sequenza;
    JTextField txtNome;
    JTextArea txtSeq;

    public FinestraInput(Sequenza unaSequenza)
    {
    setTitle("Inserimento sequenza di aminoacidi");
    setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
    JPanel p = (JPanel) getContentPane();
    p.setLayout (new BorderLayout ());

    JPanel p1 = new JPanel ();
    p1.add (new JLabel ("Nome Sequenza: "));

    txtNome = new JTextField (10);
    p1.add (txtNome);
    p.add (p1, "North");

    JPanel p2 = new JPanel ();
    p2.setLayout (new BorderLayout ());
    p2.add (new JLabel ("Sequenza di Aminoacidi: "), "North");
    
    txtSeq = new JTextArea (5, 40);
    p2.add (txtSeq, "Center");
    p.add (p2, "Center");
    
    JPanel p3 = new JPanel ();
    JButton okButton = new JButton ("OK");
    okButton.addActionListener (this);
    p3.add(okButton);
    
    JButton resetButton = new JButton ("Pulisci");
    resetButton.addActionListener (this);
    p3.add(resetButton);
    
    JButton esempioButton = new JButton ("Esempio");
    esempioButton.addActionListener (this);
    p3.add(esempioButton);
    
    p.add(p3, "South");
    
    // assegna la sequenza
    sequenza = unaSequenza;

    txtNome.setText(sequenza.leggiNome());
    txtSeq.setText(sequenza.leggiSequenza());

    pack();
    }
        
    
 public void actionPerformed(ActionEvent evento) 
  {
        String comando = evento.getActionCommand();
        if (comando.equals("OK"))
            {
              gestionePulsante_OK();
            }
        else if (comando.equals("Pulisci"))
            {
              gestionePulsante_Pulisci();
            }
        else if (comando.equals("Esempio"))
            {
                gestionePulsante_Esempio();
            }
   }    


private void gestionePulsante_OK()
    {
        String nome = txtNome.getText();                
        String seq = txtSeq.getText();
        
        // ora linearizzo la sequenza togliendo i caratteri di a capo
        String seqLineare = ""; // seq senza i caratteri di a capo '\n'
        int n = seq.length();
        int i = 0;
        char c;
        while (i < n)
          {
              c = seq.charAt(i);
              if (c != '\n')
              { 
                 seqLineare = seqLineare + c;
              }                
              i++;
          }        
       
        
        sequenza.impostaNome(nome);
        int esito = sequenza.impostaAminoacidi(seqLineare);               
        if (esito == -1)  // sequenza errata!!!
           {
                JOptionPane.showMessageDialog(null, "La sequenza di aminoacidi non  valida!!!");                
                sequenza.azzera();
           }
        else
        {
            hide();
            //dispose ();     
        }    
        
    }

 private void gestionePulsante_Pulisci()
    {
        txtNome.setText("");
        txtSeq.setText("");
        sequenza.azzera();
    }


 private void gestionePulsante_Esempio()
    {
        if (sequenza.leggiNome().equals("alfa"))
        {
            txtNome.setText("alfa");
            txtSeq.setText("FNVATLPAEKMKILELPFAIKDLLVSSSTDLDTTLVLVNAIY");
         }
         else  // sequenza beta
         {
            txtNome.setText("beta");
            txtSeq.setText("FKVASMASEKMKILELPFAIRNILQPSSVDSQTAMVLVNAIA");
         }   
        
    }

}
