import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.JButton;
import javax.swing.JPanel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.JOptionPane;
import javax.swing.JComboBox;
import java.awt.Font;
import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.JScrollPane;



/**
 * classe FinestraPrincipale 
 * 
 */
public class FinestraPrincipale extends JFrame implements ActionListener
{
    // instance variables 
    private Sequenza a;
    private Sequenza b;
    private JTextArea text;
    private JScrollPane scroll;
    private JRadioButton globale;
    private JRadioButton parziale;
    private JComboBox comboBox;
    private JTextField txtd; // costo creazione gap
    private JTextField txte; // costo estensione gap


    /**
     * Constructor for objects of class FinestraPrincipale
     */
    public FinestraPrincipale()
    {
        setTitle("ALISA - Allineamento Interattivo Sequenze di Aminoacidi");
        JPanel panel = (JPanel) getContentPane();
        panel.setLayout(new BorderLayout());
        
        JPanel toolbar = new JPanel();
        toolbar.setLayout(new FlowLayout());
        
        JButton button0 = new JButton("Input 1^ Sequenza");
        JButton button1 = new JButton("Input 2^ Sequenza");
        JButton button2 = new JButton("Esegui Allineamenti");
        JButton button3 = new JButton("Informazioni");
        JButton button4 = new JButton("Esci");
               
        button0.addActionListener(this);
        button0.setActionCommand("Input1");
        toolbar.add(button0);

        button1.addActionListener(this);
        button1.setActionCommand("Input2");
        toolbar.add(button1);
       
       
        button2.addActionListener(this);
        button2.setActionCommand("Esegui");
        toolbar.add(button2);
        
        button3.addActionListener(this);
        button3.setActionCommand("Info");
        toolbar.add(button3);

        button4.addActionListener(this);
        button4.setActionCommand("Esci");
        toolbar.add(button4);
        
        panel.add(toolbar, "North");
        
        JPanel p2 = new JPanel();
        p2.setLayout(new FlowLayout());
        
        p2.add(new JLabel("Tipo: "));
        ButtonGroup gruppo = new ButtonGroup();
        globale = new JRadioButton("globale");
        parziale = new JRadioButton("parziale");
        gruppo.add(globale);
        gruppo.add(parziale);
        JPanel pgruppo = new JPanel();
        pgruppo.setBorder(new EtchedBorder());
        globale.setSelected(true);
        parziale.setSelected(false);
        pgruppo.add(globale);
        pgruppo.add(parziale);
        p2.add(pgruppo);
        
        p2.add(new JLabel("   Matrice: "));
        comboBox = new JComboBox();
        comboBox.addItem("PAM240");
        comboBox.addItem("BLOSUM50");
        comboBox.addItem("IDENTITY");
        p2.add(comboBox);

        p2.add(new JLabel("   Penalit gap: "));
        txtd = new JTextField(6);
        txte = new JTextField(6);
        txtd.setText("11");
        txte.setText("1");
        p2.add(txtd);
        p2.add(txte);      
        panel.add(p2, "Center");

        text = new JTextArea(15, 50);  
        text.setText("");
        text.setFont(new Font("Courier", Font.PLAIN, 12));
        
        scroll = new JScrollPane();        
        scroll.setViewportView(text);        
        panel.add(scroll, "South");
        
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE); // oppure EXIT_ON_CLOSE

        pack();        
        
        a = new Sequenza();
        b = new Sequenza();
        
        // metto nomi fittizi di esempio
        a.impostaNome("alfa");
        b.impostaNome("beta");        
    }




    /**
     * metodo main() 
     * 
     */
    public static void main(String args[])
    {
        FinestraPrincipale fin = new FinestraPrincipale();
        fin.setVisible(true);
    }


  public void actionPerformed(ActionEvent evento) 
  {
        String comando = evento.getActionCommand();
        if (comando.equals("Input1"))
            {
              gestionePulsante_Input(a);
            }
        else if (comando.equals("Input2"))
            {
              gestionePulsante_Input(b);
            }
        else if (comando.equals("Esegui"))
            {
               gestionePulsante_Esegui();
            }
        else if (comando.equals("Info"))
            {
            gestionePulsante_Info();
            }
        else if (comando.equals("Esci"))
            {
            gestionePulsante_Esci();
            }
  }



private void gestionePulsante_Input(Sequenza x)
{
       FinestraInput is = new FinestraInput(x);
       is.setVisible(true);
}

private void gestionePulsante_Esegui()
{
     try
     {
       if ((a.lunghezza() == 0)||(b.lunghezza() == 0))
         {
            JOptionPane.showMessageDialog(null, "Si devono prima inserire entrambe le sequenze di aminoacidi!!!");
         }
       else
         {
           String risultato = azioneEsegui();     
           text.setText(risultato);
         }
     }
     catch (Exception e)
     { 
        e.printStackTrace();
     } 

}


private void gestionePulsante_Info()
{
      String s = " ************   A L I S A   ************ \n \n";
      s = s + "Utilizza l'algoritmo di Needleman-Wunsch \n"; 
      s = s + "Realizzato in Java da Roberto Bandiera - 2003 \n \n";
      s = s + "Utilizzo: \n";
      s = s + "1) inserire le due sequenze di aminoacidi da confrontare \n";
      s = s + "2) scegliere tipo di allineamento e matrice di sostituzione \n";
      s = s + "   e impostare le penalit di gap \n";
      s = s + "3) premere il pulsante ESEGUI ALLINEAMENTI \n";
      s = s + "Il risultato comparir nella sottostante area di testo \n";
      s = s + "da dove potr essere copiato e incollato in un word processor \n";            
      JOptionPane.showMessageDialog(null, s);
}

private void gestionePulsante_Esci()
{
      //System.exit(0);
      dispose();
}


    /*
     * Metodo che attiva l'esecuzione dell'allineamento
     * 
     */
     private String azioneEsegui() throws Exception
     {        
        int d;  // penalit creazione gap
        int e;  // penalit estensione gap
        String titolo;
        String risultato = "";
        MatriceSostituzione mat;
        PenalitGap pg;
        Allineamento all;
               
        String s = (String) comboBox.getSelectedItem();
        mat = (MatriceSostituzione) Class.forName(s).newInstance();
        d = Integer.parseInt(txtd.getText());
        e = Integer.parseInt(txte.getText());
        pg = new PenalitGap(d, e);                         
        if (globale.isSelected())
           {
                  all = new AllinGlobale(a, b, mat, pg);
                  titolo = "Allineamento Globale";
           }
        else  // parziale.isSelected()
           {
                  all = new AllinParziale(a, b, mat, pg);
                  titolo = "Allineamento Parziale";
           }    
        all.eseguiAllineamento();
        int i = 0;
        risultato = titolo + " punteggio: " + all.maxPunteggio() + "\n \n";
        String[] arr = all.percorsoOttimo();
        while (i < arr.length)
           { 
               risultato += arr[i] + " (" + a.leggiNome() + ")" + "\n";
               risultato += arr[i+1] + "\n";
               risultato += arr[i+2] + " (" + b.leggiNome() + ")" + "\n";
               risultato += arr[i+3] + "\n";
               risultato += arr[i+4] + "\n \n";
               i = i + 5;
           }                           
       return risultato;   
       }       
}



      