
/**
 * Classe astratta MatriceSostituzione
 * essa rappresenta la generica matrice di sostituzione (es. BLOSUM50, ...)
 */
public abstract class MatriceSostituzione
{
    // instance variables
    private int[][] m;  // matrice di punteggi
    private String tipo;

    /**
     * Costruttore utilizzato dalle sottoclassi concrete
     * 
     */
    public MatriceSostituzione(String unTipo)  
    {
        tipo = unTipo;
    }

    /**
     * Metodo che assegna la matrice vera e propria di punteggi
     * 
     */
     public void impostaMatrice(int[][] unaMatrice)
     {
        m = unaMatrice;
     }
     
     
    /**
     * Metodo che ritorna il tipo della matrice di sostituzione
     * 
     * @return     il tipo della matrice di sostituzione
     */
    public String leggiTipo()
    {
        return tipo;
    }
    
     /**
     * Metodo che ritorna la descrizione del tipo della matrice di sostituzione
     * 
     * @return     stringa descrittiva
     */
    public String toString()
    {
        return "matrice = " + leggiTipo();
    }
    
    /**
     * Metodo che ritorna il valore della cella i,j
     *
     * @param  i  l'indice di riga
     * @param  j  l'indice di colonna
     * @return     il valore m[i][j]
     */
    public int punteggio(int i, int j)
    {
        // deve essere ((i < 20) && (j < 20))
           return m[i][j];
    }
   
}
